import math
import turtle
import random

world_turtles = []

def lonely_turtle(t):
    return t.color()[0] == 'blue'

def angry_turtle(t):
    return t.color()[0] == 'red'

def silly_turtle(t):
    return t.color()[0] == 'green'

def in_bounds(t):
    return t.distance((0,0)) < 250

def point_at(t, point):
    posx, posy = point
    angle_point = t.towards(posx, posy)
    t.seth(angle_point)
    t.forward(1)


def neighbors(me, distance):
    # We want to find our neighbors
    my_neighbors = []
    for cturtle in world_turtles:
        if ( cturtle != me and me.distance(cturtle.position()) < distance ):
            my_neighbors.append(cturtle)
    return my_neighbors

def walk(me):
    if ( in_bounds(me) == False):
        point_at(me, (0,0))
    else:
        my_neighbors = neighbors(me, 50)
        if ( angry_turtle(me) and len(my_neighbors) > 0 ):
            me.seth( 180 + me.towards(my_neighbors[0]) )
            me.forward(5)
        elif ( lonely_turtle(me) and len(my_neighbors) > 0 ):
            other = my_neighbors[0]
            if other.color()[0] == 'blue':
                me.left(5*random.random())
                me.forward(5*random.random())
            else:
                point_at(me, my_neighbors[0].position())
        else:
            me.right( -4 + ( 8*random.random()))
            me.forward(2)
        me.forward(1)


def setup():
    for x in range(0, 20):
        t = turtle.Pen()
        t.speed(0)
        t.penup()
        t.right(368*random.random())
        t.forward(200*random.random())
        t.right(360*random.random())
        t.color(random.choice(['red', 'green', 'blue']))
        world_turtles.append(t)
    print "all ready!"

def run():
    print("Start walk cycle for %d turtles" % (len(world_turtles)))
    while True:
        for t in world_turtles:
            walk(t)

setup()
run()
